#include "searchtree.h"

void stampanodo(searchtree *q)
{
	printf("[%2d]",q->v);
}

void printtree(searchtree *p);

#define NUMELEM 9
/* #define NUMELEM 20 */

int main(void)
{
	int i;
	key a[] = { 9, 5, 2, 15, 18, 17, 12, 19, 13};   
/*	key a[] = {9, 2, 5, 2, 15, 2, 18, 2, 17, 2, 15, 12, 19, 13, 2, 5, 9, 4, 5, 7}; */
	searchtree *root = createsearchtree();
	searchtree *p,*q;

	for(i = 0; i < NUMELEM; i++) {
		printf("\nInsert (%d):\t",a[i]);
		root = insert(root,a[i]);
		inorder(root,stampanodo);
	}

	putchar('\n');
	putchar('\n');
	printtree(root);
	putchar('\n');

	printf("\n\nRicerca di:\t");
	scanf("%d",&i);
	if(p = search(root,i)) {
		printf("\n Nodo %d trovato: %d.", i, p->v);
		if(q = treepred(p))
			printf("\n Predecessore di %d:\t %d", p->v, q->v );
		if(q = treesucc(p))
		printf("\n Successore di %d:\t %d", p->v, q->v );
 	}
	else
		printf("\n Nodo %d non trovato.",i);
	printf("\n Elemento minimo:\t %d", treemin(root)->v );
	printf("\n Elemento massimo:\t %d", treemax(root)->v );
	if(p) {
		printf("\n Dopo l'eliminazione di %d: \t", p->v );
		root = delete(root,p);
		inorder(root,stampanodo);
	}
	putchar('\n');

	putchar('\n');
	printtree(root);
	putchar('\n');

	destroysearchtree(root);

	return 0;
}

